/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"bytes"
	"context"
	"io"
	"net/http"
	"net/url"
)

// ServicesGoogleSheetsApiService ServicesGoogleSheetsApi service
type ServicesGoogleSheetsApiService service

type ApiAppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthProcessCallbackRequest struct {
	ctx                                                                        context.Context
	ApiService                                                                 *ServicesGoogleSheetsApiService
	appAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthProcessCallbackRequest *AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthProcessCallbackRequest
}

//
func (r ApiAppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthProcessCallbackRequest) AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthProcessCallbackRequest(appAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthProcessCallbackRequest AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthProcessCallbackRequest) ApiAppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthProcessCallbackRequest {
	r.appAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthProcessCallbackRequest = &appAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthProcessCallbackRequest
	return r
}

func (r ApiAppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthProcessCallbackRequest) Execute() (map[string]interface{}, *http.Response, error) {
	return r.ApiService.AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthProcessCallbackExecute(r)
}

/*
AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthProcessCallback Create service

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @return ApiAppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthProcessCallbackRequest
*/
func (a *ServicesGoogleSheetsApiService) AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthProcessCallback(ctx context.Context) ApiAppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthProcessCallbackRequest {
	return ApiAppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthProcessCallbackRequest{
		ApiService: a,
		ctx:        ctx,
	}
}

// Execute executes the request
//  @return map[string]interface{}
func (a *ServicesGoogleSheetsApiService) AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthProcessCallbackExecute(r ApiAppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthProcessCallbackRequest) (map[string]interface{}, *http.Response, error) {
	var (
		localVarHTTPMethod  = http.MethodPost
		localVarPostBody    interface{}
		formFiles           []formFile
		localVarReturnValue map[string]interface{}
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "ServicesGoogleSheetsApiService.AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthProcessCallback")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/services/google_sheets/oauth-process-callback"

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}
	if r.appAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthProcessCallbackRequest == nil {
		return localVarReturnValue, nil, reportError("appAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthProcessCallbackRequest is required and must be specified")
	}

	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{"application/json"}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	// body params
	localVarPostBody = r.appAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthProcessCallbackRequest
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}

type ApiAppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequest struct {
	ctx                                                                   context.Context
	ApiService                                                            *ServicesGoogleSheetsApiService
	appAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequest *AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequest
}

//
func (r ApiAppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequest) AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequest(appAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequest AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequest) ApiAppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequest {
	r.appAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequest = &appAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequest
	return r
}

func (r ApiAppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequest) Execute() (map[string]interface{}, *http.Response, error) {
	return r.ApiService.AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLExecute(r)
}

/*
AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURL Get url for service authentication

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @return ApiAppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequest
*/
func (a *ServicesGoogleSheetsApiService) AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURL(ctx context.Context) ApiAppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequest {
	return ApiAppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequest{
		ApiService: a,
		ctx:        ctx,
	}
}

// Execute executes the request
//  @return map[string]interface{}
func (a *ServicesGoogleSheetsApiService) AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLExecute(r ApiAppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequest) (map[string]interface{}, *http.Response, error) {
	var (
		localVarHTTPMethod  = http.MethodPost
		localVarPostBody    interface{}
		formFiles           []formFile
		localVarReturnValue map[string]interface{}
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "ServicesGoogleSheetsApiService.AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURL")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/services/google_sheets/oauth-request-url"

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}
	if r.appAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequest == nil {
		return localVarReturnValue, nil, reportError("appAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequest is required and must be specified")
	}

	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{"application/json"}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	// body params
	localVarPostBody = r.appAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequest
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}
